/**
 * PETALS - PETALS Services Platform. Copyright (c) 2008 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.se.jsr181;

import java.io.IOException;
import java.io.OutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMNode;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.context.ServiceContext;
import org.apache.axis2.dataretrieval.AxisDataLocator;
import org.apache.axis2.dataretrieval.Data;
import org.apache.axis2.dataretrieval.DataRetrievalRequest;
import org.apache.axis2.dataretrieval.LocatorType;
import org.apache.axis2.deployment.util.ExcludeInfo;
import org.apache.axis2.description.AxisDescription;
import org.apache.axis2.description.AxisEndpoint;
import org.apache.axis2.description.AxisModule;
import org.apache.axis2.description.AxisOperation;
import org.apache.axis2.description.AxisServiceGroup;
import org.apache.axis2.description.MessageContextListener;
import org.apache.axis2.description.ModuleConfiguration;
import org.apache.axis2.description.Parameter;
import org.apache.axis2.description.ParameterObserver;
import org.apache.axis2.description.PolicyInclude;
import org.apache.axis2.description.PolicySubject;
import org.apache.axis2.description.java2wsdl.TypeTable;
import org.apache.axis2.engine.AxisConfiguration;
import org.apache.axis2.engine.MessageReceiver;
import org.apache.axis2.engine.ObjectSupplier;
import org.apache.axis2.engine.ServiceLifeCycle;
import org.apache.neethi.Policy;
import org.apache.ws.commons.schema.XmlSchema;
import org.apache.ws.commons.schema.XmlSchemaElement;
import org.apache.ws.commons.schema.utils.NamespaceMap;
import org.ow2.petals.component.framework.jbidescriptor.generated.Provides;

/**
 * {@link org.apache.axis2.description.AxisService} delegator
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * @since 1.0
 * 
 */
public class AxisService extends org.apache.axis2.description.AxisService {

    /**
     * The linked SU provides for this Axis Service
     */
    private Provides provides;

    /**
     * The real Axis2 Service
     */
    private org.apache.axis2.description.AxisService axisService;

    /**
     * Creates a new instance of AxisService
     */
    public AxisService(final org.apache.axis2.description.AxisService axisService,
            final Provides provides) {
        this.axisService = axisService;
        this.provides = provides;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.apache.axis2.description.AxisService#printWSDL(java.io.OutputStream,
     *      java.lang.String)
     */
    @Override
    public void printWSDL(OutputStream out, String requestIP) throws AxisFault {
        System.out.println("PRINT WSDL on provider " + provides.toString());

        super.printWSDL(out, requestIP);
    }

    /**
     * @param child
     * @see org.apache.axis2.description.AxisDescription#addChild(org.apache.axis2.description.AxisDescription)
     */
    public void addChild(AxisDescription child) {
        axisService.addChild(child);
    }

    /**
     * @param key
     * @param child
     * @see org.apache.axis2.description.AxisDescription#addChild(java.lang.Object,
     *      org.apache.axis2.description.AxisDescription)
     */
    public void addChild(Object key, AxisDescription child) {
        axisService.addChild(key, child);
    }

    /**
     * @param dialect
     * @param dataLocatorClassName
     * @see org.apache.axis2.description.AxisService#addDataLocatorClassNames(java.lang.String,
     *      java.lang.String)
     */
    public void addDataLocatorClassNames(String dialect, String dataLocatorClassName) {
        axisService.addDataLocatorClassNames(dialect, dataLocatorClassName);
    }

    /**
     * @param key
     * @param axisEndpoint
     * @see org.apache.axis2.description.AxisService#addEndpoint(java.lang.String,
     *      org.apache.axis2.description.AxisEndpoint)
     */
    public void addEndpoint(String key, AxisEndpoint axisEndpoint) {
        axisService.addEndpoint(key, axisEndpoint);
    }

    /**
     * @param transport
     * @see org.apache.axis2.description.AxisService#addExposedTransport(java.lang.String)
     */
    public void addExposedTransport(String transport) {
        axisService.addExposedTransport(transport);
    }

    /**
     * @param string
     * @param axisOperation
     * @see org.apache.axis2.description.AxisService#addHttpLocationDispatcherString(java.lang.String,
     *      org.apache.axis2.description.AxisOperation)
     */
    public void addHttpLocationDispatcherString(String string, AxisOperation axisOperation) {
        axisService.addHttpLocationDispatcherString(string, axisOperation);
    }

    /**
     * @param scl
     * @see org.apache.axis2.description.AxisService#addMessageContextListener(org.apache.axis2.description.MessageContextListener)
     */
    public void addMessageContextListener(MessageContextListener scl) {
        axisService.addMessageContextListener(scl);
    }

    /**
     * @param messageElementQName
     * @param operation
     * @see org.apache.axis2.description.AxisService#addMessageElementQNameToOperationMapping(javax.xml.namespace.QName,
     *      org.apache.axis2.description.AxisOperation)
     */
    public void addMessageElementQNameToOperationMapping(QName messageElementQName,
            AxisOperation operation) {
        axisService.addMessageElementQNameToOperationMapping(messageElementQName, operation);
    }

    /**
     * @param mepURI
     * @param messageReceiver
     * @see org.apache.axis2.description.AxisService#addMessageReceiver(java.lang.String,
     *      org.apache.axis2.engine.MessageReceiver)
     */
    public void addMessageReceiver(String mepURI, MessageReceiver messageReceiver) {
        axisService.addMessageReceiver(mepURI, messageReceiver);
    }

    /**
     * @param moduleConfiguration
     * @see org.apache.axis2.description.AxisService#addModuleConfig(org.apache.axis2.description.ModuleConfiguration)
     */
    public void addModuleConfig(ModuleConfiguration moduleConfiguration) {
        axisService.addModuleConfig(moduleConfiguration);
    }

    /**
     * @param moduleref
     * @see org.apache.axis2.description.AxisService#addModuleref(java.lang.String)
     */
    public void addModuleref(String moduleref) {
        axisService.addModuleref(moduleref);
    }

    /**
     * @param axisOperation
     * @see org.apache.axis2.description.AxisService#addOperation(org.apache.axis2.description.AxisOperation)
     */
    public void addOperation(AxisOperation axisOperation) {
        axisService.addOperation(axisOperation);
    }

    /**
     * @param param
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#addParameter(org.apache.axis2.description.Parameter)
     */
    public void addParameter(Parameter param) throws AxisFault {
        axisService.addParameter(param);
    }

    /**
     * @param name
     * @param value
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#addParameter(java.lang.String,
     *      java.lang.Object)
     */
    public void addParameter(String name, Object value) throws AxisFault {
        axisService.addParameter(name, value);
    }

    /**
     * @param observer
     * @see org.apache.axis2.description.AxisDescription#addParameterObserver(org.apache.axis2.description.ParameterObserver)
     */
    public void addParameterObserver(ParameterObserver observer) {
        axisService.addParameterObserver(observer);
    }

    /**
     * @param schemas
     * @see org.apache.axis2.description.AxisService#addSchema(java.util.Collection)
     */
    public void addSchema(Collection schemas) {
        axisService.addSchema(schemas);
    }

    /**
     * @param schema
     * @see org.apache.axis2.description.AxisService#addSchema(org.apache.ws.commons.schema.XmlSchema)
     */
    public void addSchema(XmlSchema schema) {
        axisService.addSchema(schema);
    }

    /**
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#applyPolicy()
     */
    public void applyPolicy() throws AxisFault {
        axisService.applyPolicy();
    }

    /**
     * @param policy
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#applyPolicy(org.apache.neethi.Policy)
     */
    public void applyPolicy(Policy policy) throws AxisFault {
        axisService.applyPolicy(policy);
    }

    /**
     * @param mc
     * @see org.apache.axis2.description.AxisService#attachEnvelopeEvent(org.apache.axis2.context.MessageContext)
     */
    public void attachEnvelopeEvent(MessageContext mc) {
        axisService.attachEnvelopeEvent(mc);
    }

    /**
     * @param sc
     * @param mc
     * @see org.apache.axis2.description.AxisService#attachServiceContextEvent(org.apache.axis2.context.ServiceContext,
     *      org.apache.axis2.context.MessageContext)
     */
    public void attachServiceContextEvent(ServiceContext sc, MessageContext mc) {
        axisService.attachServiceContextEvent(sc, mc);
    }

    /**
     * @param parameterElement
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#deserializeParameters(org.apache.axiom.om.OMElement)
     */
    public void deserializeParameters(OMElement parameterElement) throws AxisFault {
        axisService.deserializeParameters(parameterElement);
    }

    /**
     * @param module
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#disengageModule(org.apache.axis2.description.AxisModule)
     */
    public void disengageModule(AxisModule module) throws AxisFault {
        axisService.disengageModule(module);
    }

    /**
     * @param axisModule
     * @param source
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#engageModule(org.apache.axis2.description.AxisModule,
     *      org.apache.axis2.description.AxisDescription)
     */
    public void engageModule(AxisModule axisModule, AxisDescription source) throws AxisFault {
        axisService.engageModule(axisModule, source);
    }

    /**
     * @param axisModule
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#engageModule(org.apache.axis2.description.AxisModule)
     */
    public void engageModule(AxisModule axisModule) throws AxisFault {
        axisService.engageModule(axisModule);
    }

    /**
     * @param obj
     * @return
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object obj) {
        return axisService.equals(obj);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getAxisConfiguration()
     */
    public AxisConfiguration getAxisConfiguration() {
        return axisService.getAxisConfiguration();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getAxisServiceGroup()
     */
    public AxisServiceGroup getAxisServiceGroup() {
        return axisService.getAxisServiceGroup();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getBindingName()
     */
    public String getBindingName() {
        return axisService.getBindingName();
    }

    /**
     * @param key
     * @return
     * @see org.apache.axis2.description.AxisDescription#getChild(java.lang.Object)
     */
    public AxisDescription getChild(Object key) {
        return axisService.getChild(key);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getChildren()
     */
    public Iterator getChildren() {
        return axisService.getChildren();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getClassLoader()
     */
    public ClassLoader getClassLoader() {
        return axisService.getClassLoader();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getControlOperations()
     */
    public ArrayList getControlOperations() {
        return axisService.getControlOperations();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getCustomSchemaNamePrefix()
     */
    public String getCustomSchemaNamePrefix() {
        return axisService.getCustomSchemaNamePrefix();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getCustomSchemaNameSuffix()
     */
    public String getCustomSchemaNameSuffix() {
        return axisService.getCustomSchemaNameSuffix();
    }

    /**
     * @param request
     * @param msgContext
     * @return
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#getData(org.apache.axis2.dataretrieval.DataRetrievalRequest,
     *      org.apache.axis2.context.MessageContext)
     */
    public Data[] getData(DataRetrievalRequest request, MessageContext msgContext) throws AxisFault {
        return axisService.getData(request, msgContext);
    }

    /**
     * @param locatorType
     * @param dialect
     * @return
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#getDataLocator(org.apache.axis2.dataretrieval.LocatorType,
     *      java.lang.String)
     */
    public AxisDataLocator getDataLocator(LocatorType locatorType, String dialect) throws AxisFault {
        return axisService.getDataLocator(locatorType, dialect);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getDocumentation()
     */
    public String getDocumentation() {
        return axisService.getDocumentation();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getDocumentationNode()
     */
    public OMNode getDocumentationNode() {
        return axisService.getDocumentationNode();
    }

    /**
     * @param key
     * @return
     * @see org.apache.axis2.description.AxisService#getEndpoint(java.lang.String)
     */
    public AxisEndpoint getEndpoint(String key) {
        return axisService.getEndpoint(key);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getEndpointName()
     */
    public String getEndpointName() {
        return axisService.getEndpointName();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getEndpoints()
     */
    public Map getEndpoints() {
        return axisService.getEndpoints();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getEndpointURL()
     */
    public String getEndpointURL() {
        return axisService.getEndpointURL();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getEngagedModules()
     */
    public Collection getEngagedModules() {
        return axisService.getEngagedModules();
    }

    /**
     * @return
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#getEPRs()
     */
    public String[] getEPRs() throws AxisFault {
        return axisService.getEPRs();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getExcludeInfo()
     */
    public ExcludeInfo getExcludeInfo() {
        return axisService.getExcludeInfo();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getExposedTransports()
     */
    public List getExposedTransports() {
        return axisService.getExposedTransports();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getFileName()
     */
    public URL getFileName() {
        return axisService.getFileName();
    }

    /**
     * @param dialect
     * @return
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#getGlobalDataLocator(java.lang.String)
     */
    public AxisDataLocator getGlobalDataLocator(String dialect) throws AxisFault {
        return axisService.getGlobalDataLocator(dialect);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getImportedNamespaces()
     */
    public List getImportedNamespaces() {
        return axisService.getImportedNamespaces();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getKey()
     */
    public Object getKey() {
        return axisService.getKey();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getLastupdate()
     */
    public long getLastupdate() {
        return axisService.getLastupdate();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getLastUpdate()
     */
    public long getLastUpdate() {
        return axisService.getLastUpdate();
    }

    /**
     * @param mepURL
     * @return
     * @see org.apache.axis2.description.AxisService#getMessageReceiver(java.lang.String)
     */
    public MessageReceiver getMessageReceiver(String mepURL) {
        return axisService.getMessageReceiver(mepURL);
    }

    /**
     * @param moduleName
     * @return
     * @see org.apache.axis2.description.AxisService#getModuleConfig(java.lang.String)
     */
    public ModuleConfiguration getModuleConfig(String moduleName) {
        return axisService.getModuleConfig(moduleName);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getModules()
     */
    public ArrayList getModules() {
        return axisService.getModules();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getName()
     */
    public String getName() {
        return axisService.getName();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getNamespaceMap()
     */
    public Map getNamespaceMap() {
        return axisService.getNamespaceMap();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getNameSpacesMap()
     */
    public Map getNameSpacesMap() {
        return axisService.getNameSpacesMap();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getObjectSupplier()
     */
    public ObjectSupplier getObjectSupplier() {
        return axisService.getObjectSupplier();
    }

    /**
     * @param operationName
     * @return
     * @see org.apache.axis2.description.AxisService#getOperation(javax.xml.namespace.QName)
     */
    public AxisOperation getOperation(QName operationName) {
        return axisService.getOperation(operationName);
    }

    /**
     * @param action
     * @return
     * @see org.apache.axis2.description.AxisService#getOperationByAction(java.lang.String)
     */
    public AxisOperation getOperationByAction(String action) {
        return axisService.getOperationByAction(action);
    }

    /**
     * @param messageElementQName
     * @return
     * @see org.apache.axis2.description.AxisService#getOperationByMessageElementQName(javax.xml.namespace.QName)
     */
    public AxisOperation getOperationByMessageElementQName(QName messageElementQName) {
        return axisService.getOperationByMessageElementQName(messageElementQName);
    }

    /**
     * @param soapAction
     * @return
     * @see org.apache.axis2.description.AxisService#getOperationBySOAPAction(java.lang.String)
     */
    public AxisOperation getOperationBySOAPAction(String soapAction) {
        return axisService.getOperationBySOAPAction(soapAction);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getOperations()
     */
    public Iterator getOperations() {
        return axisService.getOperations();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getOperationsNameList()
     */
    public List getOperationsNameList() {
        return axisService.getOperationsNameList();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getP2nMap()
     */
    public Map getP2nMap() {
        return axisService.getP2nMap();
    }

    /**
     * @param name
     * @return
     * @see org.apache.axis2.description.AxisDescription#getParameter(java.lang.String)
     */
    public Parameter getParameter(String name) {
        return axisService.getParameter(name);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getParameters()
     */
    public ArrayList getParameters() {
        return axisService.getParameters();
    }

    /**
     * @param name
     * @return
     * @see org.apache.axis2.description.AxisDescription#getParameterValue(java.lang.String)
     */
    public Object getParameterValue(String name) {
        return axisService.getParameterValue(name);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getParent()
     */
    public AxisDescription getParent() {
        return axisService.getParent();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisDescription#getPolicyInclude()
     */
    public PolicyInclude getPolicyInclude() {
        return axisService.getPolicyInclude();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisDescription#getPolicySubject()
     */
    public PolicySubject getPolicySubject() {
        return axisService.getPolicySubject();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getPortTypeName()
     */
    public String getPortTypeName() {
        return axisService.getPortTypeName();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getPublishedOperations()
     */
    public ArrayList getPublishedOperations() {
        return axisService.getPublishedOperations();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getSchema()
     */
    public ArrayList getSchema() {
        return axisService.getSchema();
    }

    /**
     * @param index
     * @return
     * @see org.apache.axis2.description.AxisService#getSchema(int)
     */
    public XmlSchema getSchema(int index) {
        return axisService.getSchema(index);
    }

    /**
     * @param elementQName
     * @return
     * @see org.apache.axis2.description.AxisService#getSchemaElement(javax.xml.namespace.QName)
     */
    public XmlSchemaElement getSchemaElement(QName elementQName) {
        return axisService.getSchemaElement(elementQName);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getSchemaMappingTable()
     */
    public Map getSchemaMappingTable() {
        return axisService.getSchemaMappingTable();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getSchematargetNamespace()
     */
    public String getSchematargetNamespace() {
        return axisService.getSchematargetNamespace();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getSchemaTargetNamespace()
     */
    public String getSchemaTargetNamespace() {
        return axisService.getSchemaTargetNamespace();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getSchemaTargetNamespacePrefix()
     */
    public String getSchemaTargetNamespacePrefix() {
        return axisService.getSchemaTargetNamespacePrefix();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getScope()
     */
    public String getScope() {
        return axisService.getScope();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getServiceDescription()
     */
    public String getServiceDescription() {
        return axisService.getServiceDescription();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getServiceLifeCycle()
     */
    public ServiceLifeCycle getServiceLifeCycle() {
        return axisService.getServiceLifeCycle();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getSoapNsUri()
     */
    public String getSoapNsUri() {
        return axisService.getSoapNsUri();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getTargetNamespace()
     */
    public String getTargetNamespace() {
        return axisService.getTargetNamespace();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getTargetNamespacePrefix()
     */
    public String getTargetNamespacePrefix() {
        return axisService.getTargetNamespacePrefix();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#getTypeTable()
     */
    public TypeTable getTypeTable() {
        return axisService.getTypeTable();
    }

    /**
     * @return
     * @deprecated
     * @see org.apache.axis2.description.AxisService#getWSAddressingFlag()
     */
    public String getWSAddressingFlag() {
        return axisService.getWSAddressingFlag();
    }

    /**
     * @return
     * @see java.lang.Object#hashCode()
     */
    public int hashCode() {
        return axisService.hashCode();
    }

    /**
     * @param cls
     * @return
     * @see org.apache.axis2.description.AxisService#hasMessageContextListener(java.lang.Class)
     */
    public boolean hasMessageContextListener(Class cls) {
        return axisService.hasMessageContextListener(cls);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isActive()
     */
    public boolean isActive() {
        return axisService.isActive();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isClientSide()
     */
    public boolean isClientSide() {
        return axisService.isClientSide();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isCustomWsdl()
     */
    public boolean isCustomWsdl() {
        return axisService.isCustomWsdl();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isElementFormDefault()
     */
    public boolean isElementFormDefault() {
        return axisService.isElementFormDefault();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isEnableAllTransports()
     */
    public boolean isEnableAllTransports() {
        return axisService.isEnableAllTransports();
    }

    /**
     * @param axisModule
     * @return
     * @see org.apache.axis2.description.AxisDescription#isEngaged(org.apache.axis2.description.AxisModule)
     */
    public boolean isEngaged(AxisModule axisModule) {
        return axisService.isEngaged(axisModule);
    }

    /**
     * @param moduleName
     * @return
     * @see org.apache.axis2.description.AxisDescription#isEngaged(java.lang.String)
     */
    public boolean isEngaged(String moduleName) {
        return axisService.isEngaged(moduleName);
    }

    /**
     * @param transport
     * @return
     * @see org.apache.axis2.description.AxisService#isExposedTransport(java.lang.String)
     */
    public boolean isExposedTransport(String transport) {
        return axisService.isExposedTransport(transport);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isModifyUserWSDLPortAddress()
     */
    public boolean isModifyUserWSDLPortAddress() {
        return axisService.isModifyUserWSDLPortAddress();
    }

    /**
     * @param parameterName
     * @return
     * @see org.apache.axis2.description.AxisDescription#isParameterLocked(java.lang.String)
     */
    public boolean isParameterLocked(String parameterName) {
        return axisService.isParameterLocked(parameterName);
    }

    /**
     * @param name
     * @return
     * @see org.apache.axis2.description.AxisDescription#isParameterTrue(java.lang.String)
     */
    public boolean isParameterTrue(String name) {
        return axisService.isParameterTrue(name);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isSchemaLocationsAdjusted()
     */
    public boolean isSchemaLocationsAdjusted() {
        return axisService.isSchemaLocationsAdjusted();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isUseDefaultChains()
     */
    public boolean isUseDefaultChains() {
        return axisService.isUseDefaultChains();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isUseUserWSDL()
     */
    public boolean isUseUserWSDL() {
        return axisService.isUseUserWSDL();
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#isWsdlFound()
     */
    public boolean isWsdlFound() {
        return axisService.isWsdlFound();
    }

    /**
     * @param key
     * @return
     * @see org.apache.axis2.description.AxisService#lookupPolicy(java.lang.String)
     */
    public Policy lookupPolicy(String key) {
        return axisService.lookupPolicy(key);
    }

    /**
     * @param action
     * @param axisOperation
     * @see org.apache.axis2.description.AxisService#mapActionToOperation(java.lang.String,
     *      org.apache.axis2.description.AxisOperation)
     */
    public void mapActionToOperation(String action, AxisOperation axisOperation) {
        axisService.mapActionToOperation(action, axisOperation);
    }

    /**
     * @param module
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#onDisengage(org.apache.axis2.description.AxisModule)
     */
    public void onDisengage(AxisModule module) throws AxisFault {
        axisService.onDisengage(module);
    }

    /**
     * @param axisModule
     * @param engager
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#onEngage(org.apache.axis2.description.AxisModule,
     *      org.apache.axis2.description.AxisDescription)
     */
    public void onEngage(AxisModule axisModule, AxisDescription engager) throws AxisFault {
        axisService.onEngage(axisModule, engager);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#populateSchemaMappings()
     */
    public Map populateSchemaMappings() {
        return axisService.populateSchemaMappings();
    }

    /**
     * @param overrideAbsoluteAddress
     * @return
     * @see org.apache.axis2.description.AxisService#populateSchemaMappings(boolean)
     */
    public Map populateSchemaMappings(boolean overrideAbsoluteAddress) {
        return axisService.populateSchemaMappings(overrideAbsoluteAddress);
    }

    /**
     * @param out
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#printSchema(java.io.OutputStream)
     */
    public void printSchema(OutputStream out) throws AxisFault {
        axisService.printSchema(out);
    }

    /**
     * @param out
     * @param wsdlName
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#printUserWSDL(java.io.OutputStream,
     *      java.lang.String)
     */
    public void printUserWSDL(OutputStream out, String wsdlName) throws AxisFault {
        axisService.printUserWSDL(out, wsdlName);
    }

    /**
     * @param out
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#printWSDL(java.io.OutputStream)
     */
    public void printWSDL(OutputStream out) throws AxisFault {
        axisService.printWSDL(out);
    }

    /**
     * @param out
     * @param requestIP
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#printWSDL2(java.io.OutputStream,
     *      java.lang.String)
     */
    public void printWSDL2(OutputStream out, String requestIP) throws AxisFault {
        axisService.printWSDL2(out, requestIP);
    }

    /**
     * @param out
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisService#printWSDL2(java.io.OutputStream)
     */
    public void printWSDL2(OutputStream out) throws AxisFault {
        axisService.printWSDL2(out);
    }

    /**
     * @param out
     * @param xsd
     * @return
     * @throws IOException
     * @see org.apache.axis2.description.AxisService#printXSD(java.io.OutputStream,
     *      java.lang.String)
     */
    public int printXSD(OutputStream out, String xsd) throws IOException {
        return axisService.printXSD(out, xsd);
    }

    /**
     * @param key
     * @param policy
     * @see org.apache.axis2.description.AxisService#registerPolicy(java.lang.String,
     *      org.apache.neethi.Policy)
     */
    public void registerPolicy(String key, Policy policy) {
        axisService.registerPolicy(key, policy);
    }

    /**
     * 
     * @see org.apache.axis2.description.AxisService#releaseSchemaList()
     */
    public void releaseSchemaList() {
        axisService.releaseSchemaList();
    }

    /**
     * @param key
     * @see org.apache.axis2.description.AxisDescription#removeChild(java.lang.Object)
     */
    public void removeChild(Object key) {
        axisService.removeChild(key);
    }

    /**
     * @param transport
     * @see org.apache.axis2.description.AxisService#removeExposedTransport(java.lang.String)
     */
    public void removeExposedTransport(String transport) {
        axisService.removeExposedTransport(transport);
    }

    /**
     * @param scl
     * @see org.apache.axis2.description.AxisService#removeMessageContextListener(org.apache.axis2.description.MessageContextListener)
     */
    public void removeMessageContextListener(MessageContextListener scl) {
        axisService.removeMessageContextListener(scl);
    }

    /**
     * @param opName
     * @see org.apache.axis2.description.AxisService#removeOperation(javax.xml.namespace.QName)
     */
    public void removeOperation(QName opName) {
        axisService.removeOperation(opName);
    }

    /**
     * @param param
     * @throws AxisFault
     * @see org.apache.axis2.description.AxisDescription#removeParameter(org.apache.axis2.description.Parameter)
     */
    public void removeParameter(Parameter param) throws AxisFault {
        axisService.removeParameter(param);
    }

    /**
     * @param observer
     * @see org.apache.axis2.description.AxisDescription#removeParameterObserver(org.apache.axis2.description.ParameterObserver)
     */
    public void removeParameterObserver(ParameterObserver observer) {
        axisService.removeParameterObserver(observer);
    }

    /**
     * @param active
     * @see org.apache.axis2.description.AxisService#setActive(boolean)
     */
    public void setActive(boolean active) {
        axisService.setActive(active);
    }

    /**
     * @param bindingName
     * @see org.apache.axis2.description.AxisService#setBindingName(java.lang.String)
     */
    public void setBindingName(String bindingName) {
        axisService.setBindingName(bindingName);
    }

    /**
     * @param classLoader
     * @see org.apache.axis2.description.AxisService#setClassLoader(java.lang.ClassLoader)
     */
    public void setClassLoader(ClassLoader classLoader) {
        axisService.setClassLoader(classLoader);
    }

    /**
     * @param clientSide
     * @see org.apache.axis2.description.AxisService#setClientSide(boolean)
     */
    public void setClientSide(boolean clientSide) {
        axisService.setClientSide(clientSide);
    }

    /**
     * @param customSchemaNamePrefix
     * @see org.apache.axis2.description.AxisService#setCustomSchemaNamePrefix(java.lang.String)
     */
    public void setCustomSchemaNamePrefix(String customSchemaNamePrefix) {
        axisService.setCustomSchemaNamePrefix(customSchemaNamePrefix);
    }

    /**
     * @param customSchemaNameSuffix
     * @see org.apache.axis2.description.AxisService#setCustomSchemaNameSuffix(java.lang.String)
     */
    public void setCustomSchemaNameSuffix(String customSchemaNameSuffix) {
        axisService.setCustomSchemaNameSuffix(customSchemaNameSuffix);
    }

    /**
     * @param customWsdl
     * @see org.apache.axis2.description.AxisService#setCustomWsdl(boolean)
     */
    public void setCustomWsdl(boolean customWsdl) {
        axisService.setCustomWsdl(customWsdl);
    }

    /**
     * @param documentation
     * @see org.apache.axis2.description.AxisDescription#setDocumentation(org.apache.axiom.om.OMNode)
     */
    public void setDocumentation(OMNode documentation) {
        axisService.setDocumentation(documentation);
    }

    /**
     * @param documentation
     * @see org.apache.axis2.description.AxisDescription#setDocumentation(java.lang.String)
     */
    public void setDocumentation(String documentation) {
        axisService.setDocumentation(documentation);
    }

    /**
     * @param elementFormDefault
     * @see org.apache.axis2.description.AxisService#setElementFormDefault(boolean)
     */
    public void setElementFormDefault(boolean elementFormDefault) {
        axisService.setElementFormDefault(elementFormDefault);
    }

    /**
     * @param enableAllTransports
     * @see org.apache.axis2.description.AxisService#setEnableAllTransports(boolean)
     */
    public void setEnableAllTransports(boolean enableAllTransports) {
        axisService.setEnableAllTransports(enableAllTransports);
    }

    /**
     * @param endpoint
     * @see org.apache.axis2.description.AxisService#setEndpointName(java.lang.String)
     */
    public void setEndpointName(String endpoint) {
        axisService.setEndpointName(endpoint);
    }

    /**
     * @param endpointURL
     * @see org.apache.axis2.description.AxisService#setEndpointURL(java.lang.String)
     */
    public void setEndpointURL(String endpointURL) {
        axisService.setEndpointURL(endpointURL);
    }

    /**
     * @param eprs
     * @see org.apache.axis2.description.AxisService#setEPRs(java.lang.String[])
     */
    public void setEPRs(String[] eprs) {
        axisService.setEPRs(eprs);
    }

    /**
     * @param excludeInfo
     * @see org.apache.axis2.description.AxisService#setExcludeInfo(org.apache.axis2.deployment.util.ExcludeInfo)
     */
    public void setExcludeInfo(ExcludeInfo excludeInfo) {
        axisService.setExcludeInfo(excludeInfo);
    }

    /**
     * @param transports
     * @see org.apache.axis2.description.AxisService#setExposedTransports(java.util.List)
     */
    public void setExposedTransports(List transports) {
        axisService.setExposedTransports(transports);
    }

    /**
     * @param fileName
     * @see org.apache.axis2.description.AxisService#setFileName(java.net.URL)
     */
    public void setFileName(URL fileName) {
        axisService.setFileName(fileName);
    }

    /**
     * @param importedNamespaces
     * @see org.apache.axis2.description.AxisService#setImportedNamespaces(java.util.List)
     */
    public void setImportedNamespaces(List importedNamespaces) {
        axisService.setImportedNamespaces(importedNamespaces);
    }

    /**
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setLastupdate()
     */
    public void setLastupdate() {
        axisService.setLastupdate();
    }

    /**
     * 
     * @see org.apache.axis2.description.AxisService#setLastUpdate()
     */
    public void setLastUpdate() {
        axisService.setLastUpdate();
    }

    /**
     * @param messageElementQNameToOperationMap
     * @see org.apache.axis2.description.AxisService#setMessageElementQNameToOperationMap(java.util.Map)
     */
    public void setMessageElementQNameToOperationMap(Map messageElementQNameToOperationMap) {
        axisService.setMessageElementQNameToOperationMap(messageElementQNameToOperationMap);
    }

    /**
     * @param name
     * @see org.apache.axis2.description.AxisService#setName(java.lang.String)
     */
    public void setName(String name) {
        axisService.setName(name);
    }

    /**
     * @param namespaceMap
     * @see org.apache.axis2.description.AxisService#setNamespaceMap(org.apache.ws.commons.schema.utils.NamespaceMap)
     */
    public void setNamespaceMap(NamespaceMap namespaceMap) {
        axisService.setNamespaceMap(namespaceMap);
    }

    /**
     * @param nameSpacesMap
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setNameSpacesMap(org.apache.ws.commons.schema.utils.NamespaceMap)
     */
    public void setNameSpacesMap(NamespaceMap nameSpacesMap) {
        axisService.setNameSpacesMap(nameSpacesMap);
    }

    /**
     * @param objectSupplier
     * @see org.apache.axis2.description.AxisService#setObjectSupplier(org.apache.axis2.engine.ObjectSupplier)
     */
    public void setObjectSupplier(ObjectSupplier objectSupplier) {
        axisService.setObjectSupplier(objectSupplier);
    }

    /**
     * @param operationsNameList
     * @see org.apache.axis2.description.AxisService#setOperationsNameList(java.util.List)
     */
    public void setOperationsNameList(List operationsNameList) {
        axisService.setOperationsNameList(operationsNameList);
    }

    /**
     * @param map
     * @see org.apache.axis2.description.AxisService#setP2nMap(java.util.Map)
     */
    public void setP2nMap(Map map) {
        axisService.setP2nMap(map);
    }

    /**
     * @param parent
     * @see org.apache.axis2.description.AxisDescription#setParent(org.apache.axis2.description.AxisDescription)
     */
    public void setParent(AxisDescription parent) {
        axisService.setParent(parent);
    }

    /**
     * @param parent
     * @see org.apache.axis2.description.AxisService#setParent(org.apache.axis2.description.AxisServiceGroup)
     */
    public void setParent(AxisServiceGroup parent) {
        axisService.setParent(parent);
    }

    /**
     * @param policyInclude
     * @deprecated
     * @see org.apache.axis2.description.AxisDescription#setPolicyInclude(org.apache.axis2.description.PolicyInclude)
     */
    public void setPolicyInclude(PolicyInclude policyInclude) {
        axisService.setPolicyInclude(policyInclude);
    }

    /**
     * @param portTypeName
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setPortTypeName(java.lang.String)
     */
    public void setPortTypeName(String portTypeName) {
        axisService.setPortTypeName(portTypeName);
    }

    /**
     * @param schemaLocationsAdjusted
     * @see org.apache.axis2.description.AxisService#setSchemaLocationsAdjusted(boolean)
     */
    public void setSchemaLocationsAdjusted(boolean schemaLocationsAdjusted) {
        axisService.setSchemaLocationsAdjusted(schemaLocationsAdjusted);
    }

    /**
     * @param schemaMappingTable
     * @see org.apache.axis2.description.AxisService#setSchemaMappingTable(java.util.Map)
     */
    public void setSchemaMappingTable(Map schemaMappingTable) {
        axisService.setSchemaMappingTable(schemaMappingTable);
    }

    /**
     * @param schematargetNamespace
     * @see org.apache.axis2.description.AxisService#setSchemaTargetNamespace(java.lang.String)
     */
    public void setSchemaTargetNamespace(String schematargetNamespace) {
        axisService.setSchemaTargetNamespace(schematargetNamespace);
    }

    /**
     * @param schematargetNamespacePrefix
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setSchematargetNamespacePrefix(java.lang.String)
     */
    public void setSchematargetNamespacePrefix(String schematargetNamespacePrefix) {
        axisService.setSchematargetNamespacePrefix(schematargetNamespacePrefix);
    }

    /**
     * @param schematargetNamespacePrefix
     * @see org.apache.axis2.description.AxisService#setSchemaTargetNamespacePrefix(java.lang.String)
     */
    public void setSchemaTargetNamespacePrefix(String schematargetNamespacePrefix) {
        axisService.setSchemaTargetNamespacePrefix(schematargetNamespacePrefix);
    }

    /**
     * @param scope
     * @see org.apache.axis2.description.AxisService#setScope(java.lang.String)
     */
    public void setScope(String scope) {
        axisService.setScope(scope);
    }

    /**
     * @param documentation
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setServiceDescription(java.lang.String)
     */
    public void setServiceDescription(String documentation) {
        axisService.setServiceDescription(documentation);
    }

    /**
     * @param serviceLifeCycle
     * @see org.apache.axis2.description.AxisService#setServiceLifeCycle(org.apache.axis2.engine.ServiceLifeCycle)
     */
    public void setServiceLifeCycle(ServiceLifeCycle serviceLifeCycle) {
        axisService.setServiceLifeCycle(serviceLifeCycle);
    }

    /**
     * @param soapNsUri
     * @see org.apache.axis2.description.AxisService#setSoapNsUri(java.lang.String)
     */
    public void setSoapNsUri(String soapNsUri) {
        axisService.setSoapNsUri(soapNsUri);
    }

    /**
     * @param targetNamespace
     * @see org.apache.axis2.description.AxisService#setTargetNamespace(java.lang.String)
     */
    public void setTargetNamespace(String targetNamespace) {
        axisService.setTargetNamespace(targetNamespace);
    }

    /**
     * @param targetNamespacePrefix
     * @see org.apache.axis2.description.AxisService#setTargetNamespacePrefix(java.lang.String)
     */
    public void setTargetNamespacePrefix(String targetNamespacePrefix) {
        axisService.setTargetNamespacePrefix(targetNamespacePrefix);
    }

    /**
     * @param typeTable
     * @see org.apache.axis2.description.AxisService#setTypeTable(org.apache.axis2.description.java2wsdl.TypeTable)
     */
    public void setTypeTable(TypeTable typeTable) {
        axisService.setTypeTable(typeTable);
    }

    /**
     * @param useDefaultChains
     * @see org.apache.axis2.description.AxisService#setUseDefaultChains(boolean)
     */
    public void setUseDefaultChains(boolean useDefaultChains) {
        axisService.setUseDefaultChains(useDefaultChains);
    }

    /**
     * @param ar
     * @deprecated
     * @see org.apache.axis2.description.AxisService#setWSAddressingFlag(java.lang.String)
     */
    public void setWSAddressingFlag(String ar) {
        axisService.setWSAddressingFlag(ar);
    }

    /**
     * @param wsdlFound
     * @see org.apache.axis2.description.AxisService#setWsdlFound(boolean)
     */
    public void setWsdlFound(boolean wsdlFound) {
        axisService.setWsdlFound(wsdlFound);
    }

    /**
     * @return
     * @see org.apache.axis2.description.AxisService#toString()
     */
    public String toString() {
        return axisService.toString();
    }

}
